/* 
 * Author: Jeff Thompson
 *
 * BSD license, See the LICENSE file for more information.
 */

#ifndef NDN_BINARYXML_H
#define	NDN_BINARYXML_H

#ifdef	__cplusplus
extern "C" {
#endif

enum {
  ndn_BinaryXML_EXT = 0x00, 	
  ndn_BinaryXML_TAG = 0x01, 
  ndn_BinaryXML_DTAG = 0x02, 
  ndn_BinaryXML_ATTR = 0x03, 
  ndn_BinaryXML_DATTR = 0x04, 
  ndn_BinaryXML_BLOB = 0x05, 
  ndn_BinaryXML_UDATA = 0x06, 
  ndn_BinaryXML_CLOSE = 0x0,

  ndn_BinaryXML_TT_BITS = 3,
  ndn_BinaryXML_TT_MASK = ((1 << ndn_BinaryXML_TT_BITS) - 1),
  ndn_BinaryXML_TT_VALUE_BITS = 4,
  ndn_BinaryXML_TT_VALUE_MASK = ((1 << (ndn_BinaryXML_TT_VALUE_BITS)) - 1),
  ndn_BinaryXML_REGULAR_VALUE_BITS = 7,
  ndn_BinaryXML_REGULAR_VALUE_MASK = ((1 << ndn_BinaryXML_REGULAR_VALUE_BITS) - 1),
  ndn_BinaryXML_TT_FINAL = 0x80,

  ndn_BinaryXML_DTag_Any = 13,
  ndn_BinaryXML_DTag_Name = 14,
  ndn_BinaryXML_DTag_Component = 15,
  ndn_BinaryXML_DTag_Certificate = 16,
  ndn_BinaryXML_DTag_Collection = 17,
  ndn_BinaryXML_DTag_CompleteName = 18,
  ndn_BinaryXML_DTag_Content = 19,
  ndn_BinaryXML_DTag_SignedInfo = 20,
  ndn_BinaryXML_DTag_ContentDigest = 21,
  ndn_BinaryXML_DTag_ContentHash = 22,
  ndn_BinaryXML_DTag_Count = 24,
  ndn_BinaryXML_DTag_Header = 25,
  ndn_BinaryXML_DTag_Interest = 26,	/* 20090915 */
  ndn_BinaryXML_DTag_Key = 27,
  ndn_BinaryXML_DTag_KeyLocator = 28,
  ndn_BinaryXML_DTag_KeyName = 29,
  ndn_BinaryXML_DTag_Length = 30,
  ndn_BinaryXML_DTag_Link = 31,
  ndn_BinaryXML_DTag_LinkAuthenticator = 32,
  ndn_BinaryXML_DTag_NameComponentCount = 33,	/* DeprecatedInInterest */
  ndn_BinaryXML_DTag_RootDigest = 36,
  ndn_BinaryXML_DTag_Signature = 37,
  ndn_BinaryXML_DTag_Start = 38,
  ndn_BinaryXML_DTag_Timestamp = 39,
  ndn_BinaryXML_DTag_Type = 40,
  ndn_BinaryXML_DTag_Nonce = 41,
  ndn_BinaryXML_DTag_Scope = 42,
  ndn_BinaryXML_DTag_Exclude = 43,
  ndn_BinaryXML_DTag_Bloom = 44,
  ndn_BinaryXML_DTag_BloomSeed = 45,
  ndn_BinaryXML_DTag_AnswerOriginKind = 47,
  ndn_BinaryXML_DTag_InterestLifetime = 48,
  ndn_BinaryXML_DTag_Witness = 53,
  ndn_BinaryXML_DTag_SignatureBits = 54,
  ndn_BinaryXML_DTag_DigestAlgorithm = 55,
  ndn_BinaryXML_DTag_BlockSize = 56,
  ndn_BinaryXML_DTag_FreshnessSeconds = 58,
  ndn_BinaryXML_DTag_FinalBlockID = 59,
  ndn_BinaryXML_DTag_PublisherPublicKeyDigest = 60,
  ndn_BinaryXML_DTag_PublisherCertificateDigest = 61,
  ndn_BinaryXML_DTag_PublisherIssuerKeyDigest = 62,
  ndn_BinaryXML_DTag_PublisherIssuerCertificateDigest = 63,
  ndn_BinaryXML_DTag_ContentObject = 64,	/* 20090915 */
  ndn_BinaryXML_DTag_WrappedKey = 65,
  ndn_BinaryXML_DTag_WrappingKeyIdentifier = 66,
  ndn_BinaryXML_DTag_WrapAlgorithm = 67,
  ndn_BinaryXML_DTag_KeyAlgorithm = 68,
  ndn_BinaryXML_DTag_Label = 69,
  ndn_BinaryXML_DTag_EncryptedKey = 70,
  ndn_BinaryXML_DTag_EncryptedNonceKey = 71,
  ndn_BinaryXML_DTag_WrappingKeyName = 72,
  ndn_BinaryXML_DTag_Action = 73,
  ndn_BinaryXML_DTag_FaceID = 74,
  ndn_BinaryXML_DTag_IPProto = 75,
  ndn_BinaryXML_DTag_Host = 76,
  ndn_BinaryXML_DTag_Port = 77,
  ndn_BinaryXML_DTag_MulticastInterface = 78,
  ndn_BinaryXML_DTag_ForwardingFlags = 79,
  ndn_BinaryXML_DTag_FaceInstance = 80,
  ndn_BinaryXML_DTag_ForwardingEntry = 81,
  ndn_BinaryXML_DTag_MulticastTTL = 82,
  ndn_BinaryXML_DTag_MinSuffixComponents = 83,
  ndn_BinaryXML_DTag_MaxSuffixComponents = 84,
  ndn_BinaryXML_DTag_ChildSelector = 85,
  ndn_BinaryXML_DTag_RepositoryInfo = 86,
  ndn_BinaryXML_DTag_Version = 87,
  ndn_BinaryXML_DTag_RepositoryVersion = 88,
  ndn_BinaryXML_DTag_GlobalPrefix = 89,
  ndn_BinaryXML_DTag_LocalName = 90,
  ndn_BinaryXML_DTag_Policy = 91,
  ndn_BinaryXML_DTag_Namespace = 92,
  ndn_BinaryXML_DTag_GlobalPrefixName = 93,
  ndn_BinaryXML_DTag_PolicyVersion = 94,
  ndn_BinaryXML_DTag_KeyValueSet = 95,
  ndn_BinaryXML_DTag_KeyValuePair = 96,
  ndn_BinaryXML_DTag_IntegerValue = 97,
  ndn_BinaryXML_DTag_DecimalValue = 98,
  ndn_BinaryXML_DTag_StringValue = 99,
  ndn_BinaryXML_DTag_BinaryValue = 100,
  ndn_BinaryXML_DTag_NameValue = 101,
  ndn_BinaryXML_DTag_Entry = 102,
  ndn_BinaryXML_DTag_ACL = 103,
  ndn_BinaryXML_DTag_ParameterizedName = 104,
  ndn_BinaryXML_DTag_Prefix = 105,
  ndn_BinaryXML_DTag_Suffix = 106,
  ndn_BinaryXML_DTag_Root = 107,
  ndn_BinaryXML_DTag_ProfileName = 108,
  ndn_BinaryXML_DTag_Parameters = 109,
  ndn_BinaryXML_DTag_InfoString = 110,
  ndn_BinaryXML_DTag_StatusResponse = 112,
  ndn_BinaryXML_DTag_StatusCode = 113,
  ndn_BinaryXML_DTag_StatusText = 114,
  ndn_BinaryXML_DTag_SyncNode = 115,
  ndn_BinaryXML_DTag_SyncNodeKind = 116,
  ndn_BinaryXML_DTag_SyncNodeElement = 117,
  ndn_BinaryXML_DTag_SyncVersion = 118,
  ndn_BinaryXML_DTag_SyncNodeElements = 119,
  ndn_BinaryXML_DTag_SyncContentHash = 120,
  ndn_BinaryXML_DTag_SyncLeafCount = 121,
  ndn_BinaryXML_DTag_SyncTreeDepth = 122,
  ndn_BinaryXML_DTag_SyncByteCount = 123,
  ndn_BinaryXML_DTag_SyncConfigSlice = 124,
  ndn_BinaryXML_DTag_SyncConfigSliceList = 125,
  ndn_BinaryXML_DTag_SyncConfigSliceOp = 126,
  ndn_BinaryXML_DTag_SyncNodeDeltas = 127,
  ndn_BinaryXML_DTag_SequenceNumber = 256,
  ndn_BinaryXML_DTag_CCNProtocolDataUnit = 17702112
};

#ifdef	__cplusplus
}
#endif

#endif
